package de.cnc.expression;

import de.cnc.expression.exceptions.ExpressionEvaluationException;

/**
 * Interface fr zuweisbare Ausdrcke wie
 * Variable, Indexausdrcke und Object-Attribute.
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: Assignable.java,v 1.1 2005/04/12 10:09:07 hkuecker Exp $
 */
public interface Assignable
{

    /**
     * get value
     */
    public Object eval(final AbstractRuntimeEnvironment pRunEnv)
        throws ExpressionEvaluationException;

    /**
     * set value
     */
    public void set(AbstractRuntimeEnvironment pRunEnv, Object paObjValue)
        throws ExpressionEvaluationException;

    /**
     * remove value
     * @return the removed value
     */
    public Object remove(AbstractRuntimeEnvironment pRunEnv)
        throws ExpressionEvaluationException;

}
