package de.cnc.expression;



/**
 * Erstmal luft die Typ-Prfung ber die hier festgelegten Konstanten
 * Spter sollen bei der Typ-Prfung Java-Klassen beachtet werden.
 * Dazu mssen die numerischen Operatoren aber auf alle numerischen Typen
 * umgestellt werden.
 * Dazu ist eine extra Klasse oder andere Mimik fr unbekannten Rckgabetyp
 * sowie keinen Rckgabe-Wert notwendig.
 */
public class Types {

  /**
   * private Konstruktor
   * instanziieren verboten
   */
  private Types() {}

  /**
   * return type unknown
   */
  //public static final int RET_TYPE_UNKNOWN = 0;

  /**
   * return type null
   */
  //public static final int RET_TYPE_NULL = 1;

  /**
   * return type boolean
   */
  //public static final int RET_TYPE_BOOL = 2;

  /**
   * return type numeric
   */
  //public static final int RET_TYPE_NUM = 3;

  /**
   * return type string
   */
  //public static final int RET_TYPE_STRING = 4;

  /**
   * return type date
   */
  //public static final int RET_TYPE_DATE = 5;

  /**
   * return type expression
   */
  //public static final int RET_TYPE_EXPRESSION = 6;

  /**
   * return type variable
   */
  //public static final int RET_TYPE_VARIABLE = 7;

  /**
   * return type string array
   * 
   * Eventuell wieder entfernen, da es RET_TYPE_LIST_OR_ARRAY gibt
   */
  //public static final int RET_TYPE_STRING_ARRAY = 8;

  /**
   * return type string array
   */
  //public static final int RET_TYPE_LIST_OR_ARRAY = 9;

  /**
   * return type array
   * 
   * Eventuell wieder entfernen, da es RET_TYPE_LIST_OR_ARRAY gibt
   */
  //public static final int RET_TYPE_ARRAY = 10;

  /**
   * return type day of week
   */
  //public static final int RET_TYPE_DAY_OF_WEEK = 10;

  /**
   * return type month
   */
  //public static final int RET_TYPE_MONTH = 11;


  /**
   * Prfen, ob der Type-Code iPa im Type-Array iArrPa enthalten ist
   */
  public static boolean isIn(//--
          final Class pSearchClass, //--
          final Object[] pClassArr) {
    if (pClassArr != null) 
    {
      for (int i = 0; i < pClassArr.length; i++) 
      {
          if ( ( pClassArr[i] instanceof Class ) //--
                  && ( pSearchClass.isAssignableFrom( (Class) pClassArr[i] ) ) ) 
          {
            return true;
          }
      }
    }
    return false;
  }// end method isIn

  /**
   * Prfen, ob der Type-Code RET_TYPE_UNKNOWN im bergebenen
   * Type-Array enthalten ist
   */
  public static boolean contentsUnknown(final Object[] pClassArr) {
    if (pClassArr != null) 
    {
      for (int i = 0; i < pClassArr.length; i++) 
      {
        if ( Types.UNKNOWN_CLASS.equals( pClassArr[i] ) ) 
        {
          return true;
        }
      }
    }
    return false;
  }// end method contentsUnknown

  /**
   * Prfen, ob der Type-Code iPa oder RET_TYPE_UNKNOWN
   * im Type-Array iArrPa enthalten ist
   */
  public static boolean isInOrUnknown(//--
          final Class pSearchClass, //--
          final Object[] pClassArr) {
//System.out.println( "--- pSearchClass: " + pSearchClass.getName() );
//Log.debug("pClassArr",pClassArr);
      if (pClassArr != null) 
      {
      for (int i = 0; i < pClassArr.length; i++) 
      {
          final Object typ = pClassArr[i];
//System.out.println("[" + i + "]" + typ );
        if ( Types.UNKNOWN_CLASS.equals( typ ) )
        {
//System.out.println("ret 1");
            return true;
        }
        if ( ( typ instanceof Class ) //--
                && ( pSearchClass.isAssignableFrom( (Class) typ ) ) ) 
        {
//System.out.println("ret 2");
            return true;
        }
      }
    }
    return false;
  }// end method isInOrUnknown

  /**
   * @param iTypesArr
   * @return
   */
  public static String arr2str(int[] iTypesArr)
  {
      String retStr = "[";
     for (int i = 0; i < iTypesArr.length; i++)
  {
      retStr += typ2str(iTypesArr[i]);
      if (i < iTypesArr.length - 1)
      {
          retStr += ", ";
      }
  }
      
      return retStr;
  }

  public static String typ2str(int pTypeInt)
  {
      switch (pTypeInt)
      {
          case 0 :
              return "RET_TYPE_UNKNOWN";
              
              //break;

          case 1 :
              return "RET_TYPE_NULL";
              
              //break;

          case 2 :
              return "RET_TYPE_BOOL";
              
              //break;

          case 3 :
              return "RET_TYPE_NUM";
              
              //break;

          case 4 :
              return "RET_TYPE_STRING";
              
              //break;

          case 5 :
              return "RET_TYPE_DATE";
              
              //break;

          case 6 :
              return "RET_TYPE_EXPRESSION";
              
              //break;

          case 7 :
              return "RET_TYPE_VARIABLE";
              
              //break;

          case 8 :
              return "RET_TYPE_STRING_ARRAY";
              
              //break;

          case 9 :
              return "RET_TYPE_LIST_OR_ARRAY";
              
              //break;

          case 10 :
              return "RET_TYPE_DAY_OF_WEEK";
              
              //break;

          default :
              return "???";
              //break;
      }


  }

    public final static Null NULL_CLASS = new Null();

    /**
     * Singleton for 'null'
     * 
     * @author Heiner Kcker
     * @since Aug 4, 2005
     */
    public static class Null
    {
        /**
         * Constructor .
         */
        Null()
        {
            super();
        }
    }

    public final static Unknown UNKNOWN_CLASS = new Unknown();

    /**
     * Singleton for Class 'Unknown'
     * 
     * @author Heiner Kcker
     * @since Aug 4, 2005
     */
    public static class Unknown
    {
        /**
         * Constructor .
         */
        Unknown()
        {
            super();
        }
    }

} // end class

