package de.cnc.expression.exceptions;


/**
 * wird geworfen wenn das token richtig ist, aber im token ein fehler ist
 */
public class ExpressionParseException extends Exception {

  private int iLine;
  private int iCol;
  private String strSource;

  /**
   * constructor
   */
  public ExpressionParseException(//--
          final int paIntLine, //--
          final int paIntCol, //--
          final String paStrSource, //--
          final String paStrErrorMessage) {
    super(paStrErrorMessage);
    this.iLine = paIntLine;
    this.iCol = paIntCol;
    this.strSource = paStrSource;
  }

  public int getLine() {
    return this.iLine;
  }

  public int getCol() {
    return this.iCol;
  }

  public String getMessage() {
    return super.getMessage() + " line:" + this.iLine
        + " col:" + this.iCol + "\n"       // col
        + this.strSource + "\n"            // source
        + spaces(this.iCol) + "^\n";       // advice arrow
  }

  /**
   * liefert eine gewnschte Anzahl Leerzeichen
   */
  private static String spaces(int paIntCount) {
    StringBuffer sb = new StringBuffer();

    for (int i = 0; i < paIntCount; i++) {
      sb.append(' ');
    }
    return sb.toString();
  }

}// end class ExpressionParseException
