package de.cnc.expression.functions;


import java.util.ArrayList;
import java.util.List;

import de.cnc.expression.AbstractRuntimeEnvironment;
import de.cnc.expression.exceptions.ExpressionEvaluationException;
import de.cnc.expression.exceptions.ExpressionParseException;


/**
 * arrayToList( &lt;value&gt; ) . <br>
 * wandelt das bergebene Array in eine java.util.ArrayList um . <br>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class ArrayToListNotNullFunction extends ArrayToListFunction {

  /**
   * constructor
   */
  public ArrayToListNotNullFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public final Object eval(final AbstractRuntimeEnvironment pRunEnv) 
      throws ExpressionEvaluationException 
  {
      final ArrayList list = (ArrayList) super.eval(pRunEnv);
      if ( list == null )
      {
          return new ArrayList( 0 ); // Collections.EMPTY_LIST;
      }
      return list;
  }// end method eval

  

    /* (non-Javadoc)
     * @see de.cnc.expression.AbstractToken#getCheckReturnTypes(de.cnc.expression.AbstractRuntimeEnvironment)
     */
    public final Object[] getCheckReturnTypes(final AbstractRuntimeEnvironment pRunEnv)
            throws ExpressionParseException
    {
        super.getCheckReturnTypes(pRunEnv);
        return new Object[] { List.class };
    }
} // end class
