package de.cnc.expression.functions;


import java.math.BigDecimal;

import de.cnc.expression.AbstractRuntimeEnvironment;
import de.cnc.expression.exceptions.ExpressionEvaluationException;
import de.cnc.expression.exceptions.ExpressionParseException;


/**
 * charCode( &lt;valueString&gt; ) . <br>
 * asc( &lt;valueString&gt; ) . <br>
 * liefert einen String der Lnge 1 mit dem Character, das der bergebenen Zahl entspricht
 */
public class AscFunction extends AbstractFunction {

  /**
   * constructor
   */
  public AscFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public final Object eval(final AbstractRuntimeEnvironment pRunEnv) throws ExpressionEvaluationException {
//    String strValue = null;
//
//    try {
//      strValue = (String) this.paramList.get(0).eval(pRunEnv);
//    } catch (Exception e) {
//      throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(),
//          "parameter is no string " + e);
//    }
//    if (strValue == null) {
//      throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(), "parameter missed");
//    }
      String strValue = getStringParamNoNull(pRunEnv, 0);

    try {
      return new BigDecimal((strValue.charAt(0)));
    } catch (Exception e) {
      // System.out.println( ""+e ) ;
      // throw new ExpressionEvaluationException(getLine(), getCol(),getSource() , getOriginalSource(), "" + e);
      return new BigDecimal(0);
    }

  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public final Object[] getCheckReturnTypes(//--
          final AbstractRuntimeEnvironment pRunEnv)
      throws ExpressionParseException
  {
    checkParamCount(1);

    checkParameterForString(0, pRunEnv);

    return new Object[]{ Number.class };
  }// end method getCheckReturnTypes

} // end class
