package de.cnc.expression.functions;


import de.cnc.expression.AbstractRuntimeEnvironment;
import de.cnc.expression.exceptions.ExpressionEvaluationException;
import de.cnc.expression.exceptions.ExpressionParseException;


/**
 * char( &lt;valueNumber&gt; ) . <br>
 * chr( &lt;valueNumber&gt; ) . <br>
 * liefert einen String der Lnge 1 mit dem Character, das der bergebenen Zahl entspricht
 */
public class CharFunction extends AbstractFunction {

  /**
   * constructor
   */
  public CharFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public final Object eval(final AbstractRuntimeEnvironment pRunEnv) throws ExpressionEvaluationException {
//    Number numCode = null;
//
//    try {
//      numCode = (Number) paramList.get(0).eval(pRunEnv);
//    } catch (Exception e) {
//      throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(),
//          "parameter is no number " + e);
//    }
//    if (numCode == null) {
//      throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(), "parameter missed");
//    }
      Number numCode = getNumberParamNoNull(pRunEnv, 0);
    try {
      StringBuffer sb = new StringBuffer();

      sb.append(((char) numCode.intValue()));
      return sb.toString() ;
    } catch (Exception e) {
      // System.out.println( ""+e ) ;
      // throw new ExpressionEvaluationException(getLine(), getCol(),getSource() , getOriginalSource(), "" + e);
      return "";
    }

  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public final Object[] getCheckReturnTypes(//--
          final AbstractRuntimeEnvironment pRunEnv)
      throws ExpressionParseException
  {
    checkParamCount(1);

    checkParameterForNumber(0,pRunEnv);

    //return new Object[]{ String.class };
    return new Object[]{ String.class };
  }// end method getCheckReturnTypes

} // end class
