package de.cnc.expression.functions;


import de.cnc.expression.AbstractRuntimeEnvironment;
import de.cnc.expression.exceptions.ContinueSequenceException;
import de.cnc.expression.exceptions.ExpressionEvaluationException;
import de.cnc.expression.exceptions.ExpressionParseException;


/**
 * continueSequence()<br>
 * contSequ()<br>
 * Startet die aktuelle Sequenz von vorn.<br>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: ContinueSequenceFunction.java,v 1.1 2005/04/12 10:09:25 hkuecker Exp $
 */
public class ContinueSequenceFunction extends AbstractFunction {

  /**
   * constructor
   */
  public ContinueSequenceFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public final Object eval(final AbstractRuntimeEnvironment pRunEnv) throws ExpressionEvaluationException {
    // return null;
    throw new ContinueSequenceException();
  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public final Object[] getCheckReturnTypes(//--
          final AbstractRuntimeEnvironment pRunEnv)
      throws ExpressionParseException
  {
    checkParamCount(0);
    //return new int[] {Types.RET_TYPE_NULL };
    //return new Object[]{ Types.NULL_CLASS };
    return new Object[]{};
  }// end method getCheckReturnTypes

} // end class
