package de.cnc.expression.functions;


import java.util.ArrayList;
import java.util.List;

import de.cnc.expression.AbstractRuntimeEnvironment;
import de.cnc.expression.exceptions.ExpressionEvaluationException;
import de.cnc.expression.exceptions.ExpressionParseException;


/**
 * emptyList( ) . <br>
 * Liefert eine leere java.util.ArrayList . <br>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: $
 */
public class EmptyListFunction extends AbstractFunction {

  /**
   * constructor
   */
  public EmptyListFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public final Object eval(final AbstractRuntimeEnvironment pRunEnv) 
      throws ExpressionEvaluationException 
  {
    return new ArrayList();
  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public final Object[] getCheckReturnTypes(//--
          final AbstractRuntimeEnvironment pRunEnv)
      throws ExpressionParseException
  {
    checkParamCount(0);

    //return new int[] {Types.RET_TYPE_LIST_OR_ARRAY };
    return new Object[]{ List.class };
  }// end method getCheckReturnTypes

  /* (non-Javadoc)
   * @see de.cnc.expression.AbstractToken#isConst(de.cnc.expression.AbstractRuntimeEnvironment)
   */
  public boolean isConst(AbstractRuntimeEnvironment pRunEnv) throws ExpressionEvaluationException
  {
      return true;
  }

  /* (non-Javadoc)
   * @see de.cnc.expression.AbstractToken#getConstVal(de.cnc.expression.AbstractRuntimeEnvironment)
   */
  public Object getConstVal(AbstractRuntimeEnvironment pRunEnv) throws ExpressionEvaluationException
  {
      return new ArrayList();
  }

} // end class
