package de.cnc.expression.functions;


import de.cnc.expression.AbstractRuntimeEnvironment;
import de.cnc.expression.exceptions.ExpressionEvaluationException;
import de.cnc.expression.exceptions.ExpressionParseException;


/**
 * endsWith( &lt;valueString&gt; , &lt;endString&gt; ) . <br>
 * endsWith-Function like java.lang.String.endsWith()
 */
public class EndsWithFunction extends AbstractFunction {

  /**
   * constructor
   */
  public EndsWithFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public final Object eval(final AbstractRuntimeEnvironment pRunEnv) throws ExpressionEvaluationException {
//    String strValue = null;
//
//    try {
//      strValue = (String) paramList.get(0).eval(pRunEnv);
//    } catch (Exception e) {
//      throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(),
//          "first parameter is no string " + e);
//    }
//    if (strValue == null) {
//      throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(), "first parameter missed");
//    }
      final String strValue = getStringParamNoNull(pRunEnv,0);
//    String strEnd = null;
//
//    try {
//      strEnd = (String) this.paramList.get(1).eval(pRunEnv);
//    } catch (Exception e) {
//      throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(),
//          "second parameter is no number " + e);
//    }
//    if (strEnd == null) {
//      throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(),
//          "second parameter missed");
//    }

      final String strEnd = getStringParamNoNull(pRunEnv, 1);
      
    try {
      return (strValue.endsWith(strEnd)) ? Boolean.TRUE : Boolean.FALSE;
    } catch (Exception e) {
      // System.out.println( ""+e ) ;
      // throw new ExpressionEvaluationException(getLine(), getCol(),getSource() , getOriginalSource(), "" + e);
      return Boolean.FALSE;
    }

  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public final Object[] getCheckReturnTypes(//--
          final AbstractRuntimeEnvironment pRunEnv)
      throws ExpressionParseException
  {
    checkParamCount(2, 3);

    checkParameterForString(0,pRunEnv);

    checkParameterForString(1,pRunEnv);

    //return new int[] {Types.RET_TYPE_BOOL };
    return new Object[]{ Boolean.class };
  }// end method getCheckReturnTypes

} // end class
