package de.cnc.expression.functions;


import de.cnc.expression.AbstractRuntimeEnvironment;
import de.cnc.expression.Types;
import de.cnc.expression.exceptions.ExpressionEvaluationException;
import de.cnc.expression.exceptions.ExpressionParseException;
import de.cnc.expression.util.TimeOut;


/**
 *  for( &lt;startExpression&gt; , &lt;booleanExpression&gt; , &lt;stepExpression&gt; , &lt;bodyExpression&gt; ) . <br>
 * ifor( &lt;startExpression&gt; , &lt;booleanExpression&gt; , &lt;stepExpression&gt; , &lt;bodyExpression&gt; ) . <br>
 * Ausfhrung der Body-Expression solange der erste Parameter true ist<br>
 */
public class ForFunction extends AbstractFunction {

  /**
   * constructor
   */
  public ForFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public final Object eval(final AbstractRuntimeEnvironment pRunEnv) throws ExpressionEvaluationException {
    getObjectParamNullable(pRunEnv, 0) ; // startExpression
    Object retObject = null;

    while (getBooleanParamNoNull(pRunEnv, 1).booleanValue()) { // condition
      if (TimeOut.isTimeOut()) {
        throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(), "expression timed out");
      }

      retObject = getObjectParamNullable(pRunEnv, 3); // bodyExpression
      getObjectParamNullable(pRunEnv, 2) ; // stepExpression
    }
    return retObject;
  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public final Object[] getCheckReturnTypes(//--
          final AbstractRuntimeEnvironment pRunEnv)
      throws ExpressionParseException
  {
    checkParamCount(4);

    checkParam(0, pRunEnv);

    checkParameterForBoolean(1,pRunEnv);

    checkParam(2, pRunEnv);
    
    //return new int[] {Types.RET_TYPE_UNKNOWN };
    //return new Object[]{ Types.UNKNOWN_CLASS };
    return this.paramList.get(3).getCheckReturnTypes(pRunEnv);
  }// end method getCheckReturnTypes

} // end class
