package de.cnc.expression.functions;


import de.cnc.expression.AbstractRuntimeEnvironment;
import de.cnc.expression.exceptions.ExpressionEvaluationException;
import de.cnc.expression.exceptions.ExpressionParseException;


/**
 * lower( &lt;valueString&gt; ) . <br>
 * lower-Function like java.lang.String.toLowerCase()
 */
public class TrimFunction extends AbstractFunction {

  /**
   * constructor
   */
  public TrimFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public final Object eval(final AbstractRuntimeEnvironment pRunEnv) throws ExpressionEvaluationException {
//    String strValue = null;
//
//    try {
//      strValue = (String) paramList.get(0).eval(pRunEnv);
//    } catch (Exception e) {
//      throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(),
//          "parameter is no string " + e);
//    }
//    if (strValue == null) {
//      throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(), "first parameter missed or null");
//    }
      String strValue = getStringParamNoNull(pRunEnv, 0);
    try {
      return strValue.trim();
    } catch (Exception e) {
      // System.out.println( ""+e ) ;
      // throw new ExpressionEvaluationException(getLine(), getCol(),getSource() , getOriginalSource(), "" + e);
      return "";
    }

  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public final Object[] getCheckReturnTypes(//--
          final AbstractRuntimeEnvironment pRunEnv)
      throws ExpressionParseException
  {
    checkParamCount(1);

    checkParameterForString(0,pRunEnv);

    return new Object[]{ String.class };
  }// end method getCheckReturnTypes

} // end class
