package de.cnc.expression.functions;


import de.cnc.expression.AbstractRuntimeEnvironment;
import de.cnc.expression.Types;
import de.cnc.expression.exceptions.ExpressionEvaluationException;
import de.cnc.expression.exceptions.ExpressionParseException;
import de.cnc.expression.util.TimeOut;


/**
 *  while( &lt;booleanExpression&gt; , &lt;bodyExpression&gt; ) . <br>
 * iwhile( &lt;booleanExpression&gt; , &lt;bodyExpression&gt; ) . <br>
 * Ausfhrung der Body-Expression solange der erste Parameter true ist<br>
 */
public class WhileFunction extends AbstractFunction {

  /**
   * constructor
   */
  public WhileFunction(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public final Object eval(final AbstractRuntimeEnvironment pRunEnv) throws ExpressionEvaluationException {
    Object retObject = null;

    while (getBooleanParamNoNull(pRunEnv, 0).booleanValue()) {
      if (TimeOut.isTimeOut()) {
        throw new ExpressionEvaluationException(getLine(), getCol(), getSource(), getOriginalSource(), "expression timed out");
      }

      retObject = getObjectParamNullable(pRunEnv, 1);
    }
    return retObject;
  }// end method eval

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public final Object[] getCheckReturnTypes(//--
          final AbstractRuntimeEnvironment pRunEnv)
      throws ExpressionParseException
  {
    checkParamCount(2);

    checkParameterForBoolean(0,pRunEnv);

    return new Object[]{ Types.UNKNOWN_CLASS };
  }// end method getCheckReturnTypes

} // end class
