package de.cnc.expression.tokencomplex;


import de.cnc.expression.AbstractRuntimeEnvironment;
import de.cnc.expression.AbstractToken;
import de.cnc.expression.Expression;
import de.cnc.expression.exceptions.ExpressionEvaluationException;
import de.cnc.expression.exceptions.ExpressionParseException;
import de.cnc.expression.util.ParserUtil;


public class ParenthesisArea extends AbstractToken {

  /** inner expression */
  protected Expression innerExp;

  public static ParenthesisArea parse(String paStr, int paIntLine, int paIntCol, String paStrOriginalSource)
    throws  ExpressionParseException { // , NoSuchTokenException {

    ParenthesisArea parenthArea = new ParenthesisArea(paStrOriginalSource, paIntLine, paIntCol);

    /*
     int iRun = 0;

     // null bis beliebig viele weisse zeichen
     int iWhites = DomainParserUtil.parseWhites(paStr.substring(iRun));

     //System.out.println("1iWhites:" + iWhites);
     //System.out.println("2iRun:" + iRun);
     iRun += iWhites;
     //System.out.println("3iRun:" + iRun);
     //System.out.println("4paStr.substring(iRun):" + paStr.substring(iRun));

     */
    // danach eine ffnende Klammer
    // if (!(iRun < paStr.length() && paStr.charAt(iRun) == '(')) {
    if (!(0 < paStr.length() && paStr.charAt(0) == '(')) {
      return null; // throw new NoSuchTokenException(paIntLine, paIntCol, paStr, "no parenthesis area");
    }
    // iRun++;
    int iRun = 1;

    // danach null bis beliebig viele weisse zeichen
    int iWhites = ParserUtil.parseWhitesAndComments(paStr.substring(iRun));

    // System.out.println("5iWhites:" + iWhites);
    // System.out.println("6iRun:" + iRun);
    iRun += iWhites;
    // System.out.println("7iRun:" + iRun);
    // System.out.println("8paStr.substring(iRun):" + paStr.substring(iRun));
    // System.out.println("9paStr.charAt(iRun):" + paStr.charAt(iRun));

    if (iRun < paStr.length() && paStr.charAt(iRun) == ')') {// System.out.println("10");
      // es folgt sofort eine schliessende Klammer
    }
    else {
      // es folgt eine innere Expression
      parenthArea.innerExp = Expression.parseEasy(paStr.substring(iRun), paIntLine, iRun, paStrOriginalSource);
      iRun += parenthArea.innerExp.getSrcLength();

      // danach null bis beliebig viele weisse zeichen
      iWhites = ParserUtil.parseWhitesAndComments(paStr.substring(iRun));
      // System.out.println("11iWhites:" + iWhites);
      // System.out.println("12iRun:" + iRun);
      iRun += iWhites;
      // schliessende Klammer
      if (!(iRun < paStr.length() && paStr.charAt(iRun) == ')')) {
        // keine schliessende Klammer gefunden
        throw new ExpressionParseException(paIntLine, iRun, paStr, "')' expected");
      }
    }
    iRun++;
    parenthArea.strSource = paStr.substring(0, iRun);
    parenthArea.iSrcLength = iRun;

    return parenthArea;

  }// end method parse

  /**
   * constructor
   */
  public ParenthesisArea(String paStrOriginalSource, int paIntLine, int paIntCol) {
    super(paStrOriginalSource, paIntLine, paIntCol);
  }// end constructor

  /**
   * process the token
   */
  public final Object eval(final AbstractRuntimeEnvironment pRunEnv) throws ExpressionEvaluationException {
    return this.innerExp.eval(pRunEnv);
  }

  public String toString() {
    String strRet = getClass().getName() + " srcLength: " + getSrcLength() + " source: " + getSource() + "\n"
        + "inner expression: " + this.innerExp;

    return strRet;
  }

  /**
   * rekursives Aufrufen der Klammerung der Ausdrcke
   * entsprechend der Operator-Prioritt.
   * Weiterleiten an den enthaltenen Ausdruck
   */
  public final void organizeOperatorPriority()
  {
      this.innerExp.organizeOperatorPriority();
  }

  /**
   * get the wahrscheinlichen return typen . <br>
   * Wahrscheinlicher Return Type zum vorbeugenden Prfen der Funktionsparameter
   * null wenn kein Rckgabe-Wert,
   * mehrere wenn mehrere mglich
   * ( z.B. Plus-Operator kann numerisch oder String liefern)
   */
  public final Object[] getCheckReturnTypes(//--
          final AbstractRuntimeEnvironment pRunEnv)
      throws ExpressionParseException
  {
    return this.innerExp.getCheckReturnTypes(pRunEnv);
  }// end method getReturnTypes

  /* (non-Javadoc)
   * @see de.cnc.expression.AbstractToken#isConst(de.cnc.expression.AbstractRuntimeEnvironment)
   */
  public final boolean isConst(final AbstractRuntimeEnvironment pRunEnv) throws ExpressionEvaluationException
  {
      return this.innerExp.isConst(pRunEnv);
  }

  /* (non-Javadoc)
   * @see de.cnc.expression.AbstractToken#getConstVal(de.cnc.expression.AbstractRuntimeEnvironment)
   */
  public final Object getConstVal(final AbstractRuntimeEnvironment pRunEnv) throws ExpressionEvaluationException
  {
      return this.innerExp.getConstVal(pRunEnv);
  }

}// end class
