package de.cnc.expression.util;


import java.util.ArrayList;

import de.cnc.expression.infixoperators.AbstractInfixOperator;


/**
 * auf AbstractInfixOperator typisierte ArrayList . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: AbstractInfixOperatorArrayList.java,v 1.1 2005/04/12 10:09:30 hkuecker Exp $
 */
public class AbstractInfixOperatorArrayList {

  /**
   * eigentliche ArrayList
   */
  private final ArrayList arrList = new ArrayList();

  /**
   * typisiertes get
   */
  public AbstractInfixOperator get(int iPaIndex) {
    if (iPaIndex < 0 || iPaIndex >= this.arrList.size())
    {
//System.out.println( "index " + iPaIndex + " out of bounds " + ( clArrayList.size() - 1 ) );
        return null;
    }
    return (AbstractInfixOperator) this.arrList.get(iPaIndex);
  }// end method get

  /**
   * typisiertes letztes Element
   */
  public AbstractInfixOperator tail() {
    return (AbstractInfixOperator) this.arrList.get(this.arrList.size() - 1);
  }// end method tail

  /**
   * typisiertes add
   */
  public boolean add(AbstractInfixOperator strPaValue) {
    return this.arrList.add(strPaValue);
  }// end method add

  /**
   * size
   */
  public int size() {
    return this.arrList.size();
  }// end method size

  /**
   * Debug-Ausgabe
   */
  public String toString() {
    return "" + this.arrList;
  }// end method toString

} // end class AbstractInfixOperatorArrayList
