package de.cnc.expression.util;

import java.math.BigDecimal;
import java.math.BigInteger;


/**
 * Stellt Hilfsmethoden fr Reflection zur Verfgung
 *
 * @author Heiner Kcker
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 */
public class ReflectionUtil
{

    public static Object convertNumberObject(//--
            final Object pSrcObj, //--
            final Class  pDstClass)
    {
        if (pSrcObj == null )
        {
            return null;
        }
        if (! ( Number.class.isAssignableFrom( pDstClass )
                && pSrcObj instanceof Number ) )
        {
            //keine Number
            return pSrcObj;
        }
        if ( pDstClass.isAssignableFrom( pSrcObj.getClass() ) )
        {
            //Klasse passt
            return pSrcObj;
        }

        final Number srcNum = (Number) pSrcObj;
        
        //@todo: zur Beschleunigung auf HashMap umstellen
       if (Integer.class.isAssignableFrom( pDstClass ) )
       {
          return new Integer( srcNum.intValue() );
       }
       if (Long.class.isAssignableFrom( pDstClass ) )
       {
          return new Long( srcNum.longValue() );
       }
       if (Double.class.isAssignableFrom( pDstClass ) )
       {
          return new Double( srcNum.doubleValue() );
       }
       if (Float.class.isAssignableFrom( pDstClass ) )
       {
          return new Float( srcNum.floatValue() );
       }
       if (Short.class.isAssignableFrom( pDstClass ) )
       {
          return new Short( srcNum.shortValue() );
       }
       if (Byte.class.isAssignableFrom( pDstClass ) )
       {
          return new Byte( srcNum.byteValue() );
       }
       if (BigDecimal.class.isAssignableFrom( pDstClass ) )
       {
          return new BigDecimal( srcNum.doubleValue() );
       }
       if (BigInteger.class.isAssignableFrom( pDstClass ) )
       {
          return new BigInteger( "" + srcNum.longValue() );
       }
       throw new RuntimeException( "not reachable code" + pSrcObj + " class " + pSrcObj.getClass() );
    } // end method typeName2ClassName

}
