package de.cnc.expression.util;


import java.util.ArrayList;

import de.cnc.expression.AbstractRuntimeEnvironment;
import de.cnc.expression.AbstractToken;
import de.cnc.expression.SubExpression;
import de.cnc.expression.exceptions.ExpressionEvaluationException;


/**
 * auf SubExpressionArrayList typisierte ArrayList . <br/>
 *
 * <br/>
 * <b>Author:</b> <a href="http://www.heinerkuecker.de" target="_blank">Heiner Kcker</a><br/>
 * <br/>
 *
 * @author Heiner Kcker
 * @version $Id: SubExpressionArrayList.java,v 1.1 2005/04/12 10:09:31 hkuecker Exp $
 */
public class SubExpressionArrayList {

  /**
   * eigentliche ArrayList
   */
  private final ArrayList arrList = new ArrayList();

  /**
   * typisiertes get
   */
  public SubExpression get(int iPaIndex) {
      if (iPaIndex < 0 || iPaIndex >= this.arrList.size())
      {
//System.out.println( "index " + iPaIndex + " out of bounds " + ( clArrayList.size() - 1 ) );
          return null;
      }
    return (SubExpression) this.arrList.get(iPaIndex);
  }// end method get

  /**
   * typisiertes letztes Element
   */
  public SubExpression tail() {
    return (SubExpression) this.arrList.get(this.arrList.size() - 1);
  }// end method tail

  /**
   * typisiertes add
   */
  public boolean add(SubExpression strPaValue) {
    return this.arrList.add(strPaValue);
  }// end method add

  /**
   * size
   */
  public int size() {
    return this.arrList.size();
  }// end method size

  /**
   * Debug-Ausgabe
   */
  public String toString() {
    return "" + this.arrList;
  }// end method toString

  /**
   * Prfen ob es sich um einen konstanten Wert (Literal oder konstanter
   * Ausdruck handelt).
   * 
   * @see de.cnc.expression.AbstractToken#isConst(de.cnc.expression.AbstractRuntimeEnvironment)
   */
  public final boolean isConst(final AbstractRuntimeEnvironment pRunEnv)
          throws ExpressionEvaluationException
  {
      for (int i = 0; i < this.arrList.size(); i++)
      {
          AbstractToken element = (AbstractToken) this.arrList.get(i);
          if (!element.isConst(pRunEnv))
          {
              return false;
          }
      }
      return true;
  }

} // end class SubExpressionArrayListArrayList
