package de.cnc.expression.util;

import java.util.Calendar;
import java.util.Date;
import java.util.GregorianCalendar;

/**
 * Year .
 * @author hkuecker
 */
public class Year
implements Comparable {

    /**
     * numerischer Code
     */
    private int value;
    
    /**
     * @return Returns the value.
     */
    public int getValue() {
        return this.value;
    }
    /**
     * Konstruktor.
     * 
     * @param pValue
     */
    public Year(//--
            final int pValue) {
        this.value = pValue;
    }

    /* (non-Javadoc)
     * @see java.lang.Object#equals(java.lang.Object)
     */
    public boolean equals(Object pObj) {
        if (pObj instanceof Year
                && ( (Year) pObj).value == this.value ) {
            return true;
        }
        return false;
    }

    /* (non-Javadoc)
     * @see java.lang.Comparable#compareTo(java.lang.Object)
     */
    public int compareTo(Object pObj) {
        return this.value - ((Year)pObj).value;
    }
    
    /**
     * get day of week for the specified date.
     * @param pDate
     * @return
     */
    public static Year getInstance(final Date pDate) {
        final GregorianCalendar cal = new GregorianCalendar();
        cal.setTime( pDate );
        int yearInt = cal.get( Calendar.YEAR );
        Year year = new Year( yearInt );
        return year;
    }

    /**
     * get month for the specified Number object.
     * @param pDate
     * @return
     */
    public static Year getInstance(final Number pNumber) {
        if (pNumber == null){
            return null;
        }
        return new Year( pNumber.intValue() );
    }

    /**
     * get month for the specified object.
     * @param pDate
     * @return
     */
    public static Year getInstance(final Object pObject) {
        if (pObject == null) {
            return null;
        }
        if (pObject instanceof Year){
            return (Year) pObject;
        }
        if  (pObject instanceof Date){
            return getInstance( (Date) pObject );
        }
        if  (pObject instanceof Number){
            return getInstance( (Number) pObject );
        }
        throw new IllegalArgumentException( "" + pObject + " class: " + pObject.getClass().getName() );
    }

    /**
     * Debug.
     */
    public String toString(){
    	return "" + this.value;
    }
}
